"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
exports.getWorkspaceInfo = getWorkspaceInfo;

var fs = _interopRequireWildcard(require("fs-extra"));

var path = _interopRequireWildcard(require("path"));

var _getAllWorkspaces = require("./getAllWorkspaces");

var _getModularRoot = _interopRequireDefault(require("./getModularRoot"));

var _memoize = _interopRequireDefault(require("./memoize"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

async function getWorkspaceInfo() {
  const workspaces = await (0, _getAllWorkspaces.getAllWorkspaces)();
  const workspaceRoot = (0, _getModularRoot.default)();
  const res = {};

  for (const [packageName, packageInfo] of Object.entries(workspaces)) {
    var _packageJson$modular;

    const packageJson = await fs.readJSON(path.join(workspaceRoot, packageInfo.location, 'package.json'));
    const type = ((_packageJson$modular = packageJson.modular) === null || _packageJson$modular === void 0 ? void 0 : _packageJson$modular.type) || 'package';
    const modularPackageInfo = { ...packageInfo,
      type,
      public: !packageJson.private,
      version: packageJson.version
    };
    res[packageName] = modularPackageInfo;
  }

  return res;
}

var _default = (0, _memoize.default)(getWorkspaceInfo);

exports.default = _default;
//# sourceMappingURL=getWorkspaceInfo.js.map