"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = stageView;

var fs = _interopRequireWildcard(require("fs-extra"));

var _path = _interopRequireDefault(require("path"));

var _changeCase = require("change-case");

var _getModularRoot = _interopRequireDefault(require("./getModularRoot"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function stageView(targetedView) {
  const modularRoot = (0, _getModularRoot.default)();

  const tempDir = _path.default.join(modularRoot, 'node_modules', '.modular');

  if (!fs.existsSync(tempDir)) {
    fs.mkdirSync(tempDir);
  }

  const stagedViewAppPath = _path.default.join(tempDir, targetedView);

  const name = (0, _changeCase.pascalCase)(targetedView);

  const workingDirectory = _path.default.join(tempDir, targetedView);

  fs.mkdirpSync(workingDirectory);
  fs.mkdirpSync(_path.default.join(workingDirectory, 'public'));
  fs.mkdirpSync(_path.default.join(workingDirectory, 'src'));
  fs.writeJsonSync(_path.default.join(workingDirectory, 'package.json'), {
    modular: {
      type: 'app'
    },
    name,
    version: '1.0.0'
  });
  fs.writeFileSync(_path.default.join(workingDirectory, 'public', 'index.html'), `<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1" />
    <meta name="theme-color" content="#000000" />
    <title>{name}</title>
  </head>
  <body>
    <div id="root"></div>
  </body>
</html>
  `);
  const indexTemplate = `import * as React from 'react';
  import * as ReactDOM from 'react-dom';
  
  import App from '${targetedView}';
  
  ReactDOM.render(
    <App />,
    document.getElementById('root'),
  );`;
  fs.writeFileSync(_path.default.join(stagedViewAppPath, 'src', 'index.tsx'), indexTemplate);
  fs.writeJSONSync(_path.default.join(stagedViewAppPath, 'tsconfig.json'), {
    extends: _path.default.relative(stagedViewAppPath, modularRoot) + '/tsconfig.json'
  }, {
    spaces: 2
  });
  return stagedViewAppPath;
}
//# sourceMappingURL=stageView.js.map